<?php

namespace Modules\Db\Http\Controllers;

use Modules\Pp\Entities\CustomerOrder;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;

class CustomerOrderStatusListController extends Controller
{
    public function allCustomerOrder($year, $month, $order_status, $production_status)
    {
        try {

            $query = 'SELECT 
            pp_customer_orders.order_id,
            pp_customer_orders.customer_name,
            pp_customer_orders.purchase_order,
            pp_customer_orders.date,
            pp_customer_orders.delivery_date,
            pp_customer_orders.production_status,
            pp_customer_orders.order_status,
            pp_customer_orders.fund_status,
            (SELECT SUM(pd_production_records_supervisor.quantity) FROM pd_production_records_supervisor
             LEFT JOIN pp_customer_order_plans_data ON pd_production_records_supervisor.customer_order_plan_data_id = pp_customer_order_plans_data.customer_order_plan_data_id
             LEFT JOIN pp_customer_orders_data ON pp_customer_order_plans_data.order_data_id = pp_customer_orders_data.order_data_id
             WHERE pp_customer_orders_data.order_id = pp_customer_orders.order_id
            ) AS daily_quantity,
            (SELECT SUM(pp_customer_order_plans_data.quantity) FROM pp_customer_order_plans_data
             LEFT JOIN pp_customer_orders_data ON pp_customer_order_plans_data.order_data_id = pp_customer_orders_data.order_data_id
             WHERE pp_customer_orders_data.order_id = pp_customer_orders.order_id
            ) AS quantity
            FROM pp_customer_orders WHERE';

            if ($year == 0 && $month == 0) {
            } else if ($year != 0 && $month == 0) {
                $date = $year . "%";
                $query .= ' pp_customer_orders.date LIKE "' . $date . '" ';
            } else if ($year == 0 && $month != 0) {
                if (strlen($month) == 1) {
                    $date = "0" . $month . "%";
                } else {
                    $date =  $month . "%";
                }
                $query .= ' MONTH(pp_customer_orders.date) = "' . $date . '" ';
            } else {
                if (strlen($month) == 1) {
                    $date = $year . "-0" . $month . "%";
                } else {
                    $date = $year . "-" . $month . "%";
                }
                $query .= ' pp_customer_orders.date LIKE "' . $date . '" ';
            }

            if ($order_status != -1) {
                preg_match('/[^ ]*$/', $query, $results);
                $last_word = $results[0];
                if ($last_word == "WHERE") {
                    $query .= ' pp_customer_orders.order_status= "' . $order_status . '" ';
                } else {
                    $query .= ' AND pp_customer_orders.order_status= "' . $order_status . '" ';
                }
            }

            if ($production_status != -1) {
                preg_match('/[^ ]*$/', $query, $results);
                $last_word = $results[0];
                if ($last_word == "WHERE") {
                    $query .= ' pp_customer_orders.production_status= "' . $production_status . '" ';
                } else {
                    $query .= ' AND pp_customer_orders.production_status= "' . $production_status . '" ';
                }
            }

            if ($order_status == -1 && $production_status == -1 && $year == 0 && $month == 0) {
                $query = 'SELECT 
                pp_customer_orders.order_id,
                pp_customer_orders.customer_name,
                pp_customer_orders.purchase_order,
                pp_customer_orders.date,
                pp_customer_orders.delivery_date,
                pp_customer_orders.production_status,
                pp_customer_orders.order_status,
                pp_customer_orders.fund_status,
                (SELECT SUM(pd_production_records_supervisor.quantity) FROM pd_production_records_supervisor
                 LEFT JOIN pp_customer_order_plans_data ON pd_production_records_supervisor.customer_order_plan_data_id = pp_customer_order_plans_data.customer_order_plan_data_id
                 LEFT JOIN pp_customer_orders_data ON pp_customer_order_plans_data.order_data_id = pp_customer_orders_data.order_data_id
                 WHERE pp_customer_orders_data.order_id = pp_customer_orders.order_id
                ) AS daily_quantity,
                (SELECT SUM(pp_customer_order_plans_data.quantity) FROM pp_customer_order_plans_data
                 LEFT JOIN pp_customer_orders_data ON pp_customer_order_plans_data.order_data_id = pp_customer_orders_data.order_data_id
                 WHERE pp_customer_orders_data.order_id = pp_customer_orders.order_id
                ) AS quantity
                FROM pp_customer_orders ';
            }

            $query .= 'GROUP BY pp_customer_orders.order_id DESC';



            $result = DB::select($query);
            // $customer_orders = CustomerOrder::where('date', 'LIKE', $date)->orderBy('order_id', 'DESC')->get();
            $responseBody = $this->responseBody(true, "CustomerOrderListController", "allCustomerOrder", $result);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "CustomerOrderListController", "allCustomerOrder", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function shipping_status(Request $request)
    {

        try {
            $id = $request->get('id');
            $status = $request->get('status');
            $order = CustomerOrder::find($id);
            if ($order) {
                $order->shipping_status = $status;
                $order->update();
            }

            $responseBody = $this->responseBody(true, "CustomerOrderListController", "shipping_status", true);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, "CustomerOrderListController", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }



    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
